// Interaktiver Brainfuck-Interpreter
// (c) Holger Guenther (hg-info@web.de), Doebeln, 10.05.2012

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License Version 2 as published
// by the Free Software Foundation. See license.txt for full details.

unit MainFrm;

interface

uses
  Classes, Controls, Forms, StdCtrls, ExtCtrls, BFThread;

type
  TMainForm = class(TForm)
    PnlOut: TPanel;
    PnlOutSizer: TPanel;
    MemoOut: TMemo;
    PnlSrc: TPanel;
    MemoSrc: TMemo;
    PnlDat: TPanel;
    EdDat: TEdit;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PnlOutSizerMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Run(Sender: TObject);
  private
    { Private-Deklarationen}
    FBFThread: TBFThread;
  public
    { Public-Deklarationen}
    procedure OnBFThreadStart (AThrd: TBFThread);
    procedure OnBFThreadResult (AThrd: TBFThread; const AnOutput: string);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.OnBFThreadStart (AThrd: TBFThread);
begin
  MemoOut.Text:='...';
end;

procedure TMainForm.OnBFThreadResult (AThrd: TBFThread;
  const AnOutput: string);
begin
  MemoOut.Text:=AnOutput;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  EdDat.Align:=alTop;
  Run (Sender);
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Application.ShowHint:=true;
  FBFThread:=TBFThread.Create;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  FBFThread.Terminate;
  FBFThread.WaitFor;
  FBFThread.Free;
end;

procedure TMainForm.PnlOutSizerMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var h,d: longint;
begin
  if not (ssLeft in Shift) then exit;
  h:=PnlOut.Height+2-Y;
  if h<PnlOut.Constraints.MinHeight then h:=PnlOut.Constraints.MinHeight;
  d:=PnlSrc.Constraints.MinHeight-(PnlSrc.Height+PnlOut.Height-h);
  if d>0 then Dec (h,d);
  PnlOut.Height:=h;
end;

procedure TMainForm.Run(Sender: TObject);
begin
  FBFThread.SetSource (MemoSrc.Text,EdDat.Text);
end;

end.

